diff -purN gdb-5.2.1-orig/gdb/gdbserver/linux-low.c gdb-5.2.1/gdb/gdbserver/linux-low.c
--- gdb-5.2.1-orig/gdb/gdbserver/linux-low.c	Thu Mar  7 21:56:18 2002
+++ gdb-5.2.1/gdb/gdbserver/linux-low.c	Tue Sep  2 14:04:41 2003
@@ -231,41 +986,45 @@ usr_store_inferior_registers (int regno)
 {
   CORE_ADDR regaddr;
   int i;
+  char *buf;
 
   if (regno >= 0)
     {
-      if (regno >= num_regs)
+      if (regno >= the_low_target.num_regs)
 	return;
 
-      if (cannot_store_register (regno))
+      if ((*the_low_target.cannot_store_register) (regno) == 1)
 	return;
 
       regaddr = register_addr (regno);
       if (regaddr == -1)
 	return;
       errno = 0;
-      for (i = 0; i < REGISTER_RAW_SIZE (regno); i += sizeof (PTRACE_XFER_TYPE))
+      buf = alloca (register_size (regno));
+      collect_register (regno, buf);
+      for (i = 0; i < register_size (regno); i += sizeof (PTRACE_XFER_TYPE))
 	{
 	  errno = 0;
 	  ptrace (PTRACE_POKEUSER, inferior_pid, (PTRACE_ARG3_TYPE) regaddr,
-		  *(int *) (register_data (regno) + i));
+		  *(int *) (buf + i));
 	  if (errno != 0)
 	    {
-	      /* Warning, not error, in case we are attached; sometimes the
-		 kernel doesn't let us at the registers.  */
-	      char *err = strerror (errno);
-	      char *msg = alloca (strlen (err) + 128);
-	      sprintf (msg, "writing register %d: %s",
-		       regno, err);
-	      error (msg);
-	      return;
+	      if ((*the_low_target.cannot_store_register) (regno) == 0)
+		{
+		  char *err = strerror (errno);
+		  char *msg = alloca (strlen (err) + 128);
+		  sprintf (msg, "writing register %d: %s",
+			   regno, err);
+		  error (msg);
+		  return;
+		}
 	    }
 	  regaddr += sizeof (int);
 	}
     }
   else
-    for (regno = 0; regno < num_regs; regno++)
-      store_inferior_registers (regno);
+    for (regno = 0; regno < the_low_target.num_regs; regno++)
+      usr_store_inferior_registers (regno);
 }
 #endif /* HAVE_LINUX_USRREGS */
 
@@ -274,7 +1033,7 @@ usr_store_inferior_registers (int regno)
 #ifdef HAVE_LINUX_REGSETS
 
 static int
-regsets_fetch_inferior_registers (void)
+regsets_fetch_inferior_registers ()
 {
   struct regset_info *regset;
 
@@ -292,7 +1051,7 @@ regsets_fetch_inferior_registers (void)
 	}
 
       buf = malloc (regset->size);
-      res = ptrace (regset->get_request, inferior_pid, 0, (int) buf);
+      res = ptrace (regset->get_request, inferior_pid, 0, buf);
       if (res < 0)
 	{
 	  if (errno == EIO)
@@ -312,16 +1071,21 @@ regsets_fetch_inferior_registers (void)
 	    }
 	  else
 	    {
-	      perror ("Warning: ptrace(regsets_fetch_inferior_registers)");
+             char s[256];
+             sprintf (s, "ptrace(regsets_fetch_inferior_registers) PID=%d",
+                      inferior_pid);
+             perror (s);
+
 	    }
 	}
       regset->store_function (buf);
       regset ++;
     }
+  return 0;
 }
 
 static int
-regsets_store_inferior_registers (void)
+regsets_store_inferior_registers ()
 {
   struct regset_info *regset;
 
@@ -340,7 +1104,7 @@ regsets_store_inferior_registers (void)
 
       buf = malloc (regset->size);
       regset->fill_function (buf);
-      res = ptrace (regset->set_request, inferior_pid, 0, (int) buf);
+      res = ptrace (regset->set_request, inferior_pid, 0, buf);
       if (res < 0)
 	{
 	  if (errno == EIO)
@@ -360,18 +1124,19 @@ regsets_store_inferior_registers (void)
 	    }
 	  else
 	    {
-	      perror ("Warning: ptrace(regsets_fetch_inferior_registers)");
+	      perror ("Warning: ptrace(regsets_store_inferior_registers)");
 	    }
 	}
       regset ++;
     }
+  return 0;
 }
 
 #endif /* HAVE_LINUX_REGSETS */
 
 
 void
-fetch_inferior_registers (int regno)
+linux_fetch_registers (int regno)
 {
 #ifdef HAVE_LINUX_REGSETS
   if (use_regsets_p)
@@ -386,7 +1151,7 @@ fetch_inferior_registers (int regno)
 }
 
 void
-store_inferior_registers (int regno)
+linux_store_registers (int regno)
 {
 #ifdef HAVE_LINUX_REGSETS
   if (use_regsets_p)
@@ -404,8 +1169,8 @@ store_inferior_registers (int regno)
 /* Copy LEN bytes from inferior's memory starting at MEMADDR
    to debugger memory starting at MYADDR.  */
 
-void
-read_inferior_memory (CORE_ADDR memaddr, char *myaddr, int len)
+static void
+linux_read_memory (CORE_ADDR memaddr, char *myaddr, int len)
 {
   register int i;
   /* Round starting address down to longword boundary.  */
@@ -433,8 +1198,8 @@ read_inferior_memory (CORE_ADDR memaddr,
    On failure (cannot write the inferior)
    returns the value of errno.  */
 
-int
-write_inferior_memory (CORE_ADDR memaddr, char *myaddr, int len)
+static int
+linux_write_memory (CORE_ADDR memaddr, const char *myaddr, int len)
 {
   register int i;
   /* Round starting address down to longword boundary.  */
@@ -446,6 +1211,11 @@ write_inferior_memory (CORE_ADDR memaddr
   register PTRACE_XFER_TYPE *buffer = (PTRACE_XFER_TYPE *) alloca (count * sizeof (PTRACE_XFER_TYPE));
   extern int errno;
 
+  if (debug_threads)
+    {
+      fprintf (stderr, "Writing %02x to %08lx\n", (unsigned)myaddr[0], (long)memaddr);
+    }
+
   /* Fill start and end extra bytes of buffer with existing memory data.  */
 
   buffer[0] = ptrace (PTRACE_PEEKTEXT, inferior_pid,
@@ -476,9 +1246,189 @@ write_inferior_memory (CORE_ADDR memaddr
 
   return 0;
 }
-
+
+static void
+linux_look_up_symbols (void)
+{
+#ifdef USE_THREAD_DB
+  if (using_threads)
+    return;
+
+  using_threads = thread_db_init ();
+#endif
+}
+
+/* Return 1 if this process is not stopped.  */
+static int
+unstopped_p (struct inferior_list_entry *entry, void *dummy)
+{
+  struct process_info *process = (struct process_info *) entry;
+
+  if (process->stopped)
+    return 0;
+
+  return 1;
+}
+
+static int
+linux_signal_pid ()
+{
+  struct inferior_list_entry *process;
+
+  process = find_inferior (&all_processes, unstopped_p, NULL);
+
+  if (process == NULL)
+    {
+      warning ("no unstopped process");
+      return inferior_pid;
+    }
+
+  return pid_of ((struct process_info *) process);
+}
+
+
+static struct target_ops linux_target_ops = {
+  linux_create_inferior,
+  linux_attach,
+#ifdef HAVE_TARGET_ATTACH
+  linux_detach,
+#endif
+  linux_kill,
+  linux_thread_alive,
+  linux_resume,
+  linux_wait,
+  linux_fetch_registers,
+  linux_store_registers,
+  linux_read_memory,
+  linux_write_memory,
+  linux_look_up_symbols,
+  linux_signal_pid,
+};
+
+static void
+linux_init_signals ()
+{
+  /* FIXME drow/2002-06-09: As above, we should check with LinuxThreads
+     to find what the cancel signal actually is.  */
+  signal (SIGRTMIN+1, SIG_IGN);
+}
+
+
 void
 initialize_low (void)
 {
+  using_threads = 0;
+  set_target_ops (&linux_target_ops);
+  set_breakpoint_data (the_low_target.breakpoint,
+		       the_low_target.breakpoint_len);
   init_registers ();
+  linux_init_signals ();
+}
+#ifdef HAVE_TARGET_SHELL
+extern int remote_desc;
+static void
+my_perror(char *s)
+{
+  const char *err;
+
+  if (errno < sys_nerr)
+    err = sys_errlist[errno];
+  else
+    err = "unknown error";
+  fprintf(stderr, "%s: ", s);
+  error(err);
+}
+
+void
+exec_shellcmd(char *args)
+{
+ int fd[2];
+ int pid, saved_pid;
+ int len;
+ char ch;
+ char buf[100];	/* must be <128 */
+ char **shell, *argv[100], **argp, *p;
+ static char *shells[] = {
+	"/bin/sh", "/bin/bash", "/bin/tcsh",
+	"/usr/bin/sh", "/usr/bin/bash", "/usr/bin/tsch", (char *)0};
+
+  if (pipe(fd))
+    perror_with_name("opening pipe");
+
+  if (current_inferior) 
+	  saved_pid = inferior_pid;
+
+  switch (pid = fork())
+    {
+    case -1:
+      perror_with_name("forking exec shell");
+      break;
+
+    case 0:
+      /* disable stdin */
+      close(0);
+      open("/dev/null", O_RDONLY);
+
+      /* redirect stdout and stderr to pipe */
+      if (dup2(fd[1], 1) != 1 || dup2(fd[1], 2) != 2)
+	{
+          my_perror("dup in exec shell");
+	  exit(1);
+	}
+      /* which shell? */
+      for (shell = shells; *shell; shell++)
+	if (access(*shell, X_OK) == 0)
+	  break;
+      if (*shell)
+        execlp(*shell, *shell, "-c", args, (char *)0);
+      else
+	{/* No shell installed. Exec it directly */
+	  for (p = args, argp = argv;
+		*p && argp < &argv[sizeof(argv)/sizeof(argv[0])] - 1; )
+	    {
+	      *argp++ = p;
+	      while (*p && !isspace(*p))
+		p++;	/* skip word */
+	      if (!*p)
+		break;	/* no more chars */
+	      *p++ = '\0';
+	      while (isspace(*p))
+		p++;	/* skip delimiting spaces */
+	      if (!*p)
+		break;	/* no more chars */
+	    }
+	  *argp = (char *)0;
+          execvp(*argv, argv);
+	}
+
+      my_perror("exec shell");
+      exit(1);
+      break;
+
+    default:	/* Parent - gdbserver */
+      close(fd[1]);	/* To get EOF properly */
+	  enable_async_io();
+	  /* To be able to stop the long output with ^C place 
+		 a fake process ID */
+	  if (current_inferior)
+		  inferior_pid = pid;
+      while (1)
+	{
+          if ((len = read(fd[0], buf, sizeof buf)) > 0)
+	    {
+		  ch = (char)len; /* We know it fit */
+	      write(remote_desc, &ch, 1);
+	      write(remote_desc, buf, len);
+	    }
+	  else if (len != -1 || errno != EINTR) 
+	      break;
+	  
+	}
+      write(remote_desc, &len, 1);	/* end mark (0) */
+      waitpid(pid, (void *)0, 0);
+      if (current_inferior)
+		  inferior_pid = saved_pid;
+      disable_async_io();
+    }
 }
+#endif
diff -purN gdb-5.2.1-orig/gdb/gdbserver/linux-low.h gdb-5.2.1/gdb/gdbserver/linux-low.h
--- gdb-5.2.1-orig/gdb/gdbserver/linux-low.h	Wed Feb 27 08:07:39 2002
+++ gdb-5.2.1/gdb/gdbserver/linux-low.h	Tue Sep  2 14:04:41 2003
@@ -18,20 +18,112 @@
    Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.  */
 
-#ifdef HAVE_LINUX_USR_REGISTERS
-extern int regmap[];
-extern int num_regs;
-int cannot_fetch_register (int regno);
-int cannot_store_register (int regno);
-#endif
-
 #ifdef HAVE_LINUX_REGSETS
-typedef void (*regset_func) (void *);
+typedef void (*regset_fill_func) (void *);
+typedef void (*regset_store_func) (const void *);
+enum regset_type {
+  GENERAL_REGS,
+  FP_REGS,
+  EXTENDED_REGS,
+};
+
 struct regset_info
 {
   int get_request, set_request;
   int size;
-  regset_func fill_function, store_function;
+  enum regset_type type;
+  regset_fill_func fill_function;
+  regset_store_func store_function;
 };
 extern struct regset_info target_regsets[];
 #endif
+
+struct linux_target_ops
+{
+  int num_regs;
+  int *regmap;
+  int (*cannot_fetch_register) (int);
+
+  /* Returns 0 if we can store the register, 1 if we can not
+     store the register, and 2 if failure to store the register
+     is acceptable.  */
+  int (*cannot_store_register) (int);
+  CORE_ADDR (*get_pc) (void);
+  void (*set_pc) (CORE_ADDR newpc);
+  const char *breakpoint;
+  int breakpoint_len;
+  CORE_ADDR (*breakpoint_reinsert_addr) (void);
+
+
+  int decr_pc_after_break;
+  int (*breakpoint_at) (CORE_ADDR pc);
+};
+
+extern struct linux_target_ops the_low_target;
+
+#define get_process(inf) ((struct process_info *)(inf))
+#define get_thread_process(thr) (get_process (inferior_target_data (thr)))
+#define get_process_thread(proc) ((struct thread_info *) \
+                                 find_inferior_id (&all_threads, \
+                                 get_process (proc)->tid))
+
+struct process_info
+{
+  struct inferior_list_entry head;
+  int thread_known;
+  int lwpid;
+  int tid;
+
+  /* If this flag is set, the next SIGSTOP will be ignored (the process will
+     be immediately resumed).  */
+  int stop_expected;
+
+  /* If this flag is set, the process is known to be stopped right now (stop
+     event already received in a wait()).  */
+  int stopped;
+
+  /* If this flag is set, we have sent a SIGSTOP to this process and are
+     waiting for it to stop.  */
+  int sigstop_sent;
+
+  /* If this flag is set, STATUS_PENDING is a waitstatus that has not yet
+     been reported.  */
+  int status_pending_p;
+  int status_pending;
+
+  /* If this flag is set, the pending status is a (GDB-placed) breakpoint.  */
+  int pending_is_breakpoint;
+  CORE_ADDR pending_stop_pc;
+
+  /* If this is non-zero, it is a breakpoint to be reinserted at our next
+     stop (SIGTRAP stops only).  */
+  CORE_ADDR bp_reinsert;
+
+  /* If this flag is set, the last continue operation on this process
+     was a single-step.  */
+  int stepping;
+
+  /* If this is non-zero, it points to a chain of signals which need to
+     be delivered to this process.  */
+  struct pending_signals *pending_signals;
+};
+extern struct inferior_list all_processes;
+
+void linux_attach_lwp (int pid, int tid);
+#ifdef HAVE_TARGET_ATTACH
+void linux_detach_lwp (int pid, int tid);
+int thread_db_deinit (void);
+#endif
+#ifdef HAVE_TARGET_SHELL
+void exec_shellcmd(char *);
+#endif
+
+int thread_db_init (void);
+
+
+
+
+
+
+
+
diff -purN gdb-5.2.1-orig/gdb/gdbserver/linux-m68k-low.c gdb-5.2.1/gdb/gdbserver/linux-m68k-low.c
--- gdb-5.2.1-orig/gdb/gdbserver/linux-m68k-low.c	Wed Feb 27 08:07:39 2002
+++ gdb-5.2.1/gdb/gdbserver/linux-m68k-low.c	Tue Sep  2 14:04:41 2003
@@ -26,10 +26,10 @@
 #include <sys/reg.h>
 #endif
 
-int num_regs = 31;
+#define m68k_num_regs 31
 
 /* This table must line up with REGISTER_NAMES in tm-m68k.h */
-int regmap[] =
+static int m68k_regmap[] =
 {
 #ifdef PT_D0
   PT_D0 * 4, PT_D1 * 4, PT_D2 * 4, PT_D3 * 4,
@@ -52,14 +52,21 @@ int regmap[] =
 #endif
 };
 
-int
-cannot_store_register (int regno)
+static int
+m68k_cannot_store_register (int regno)
 {
-  return (regno >= num_regs);
+  return (regno >= m68k_num_regs);
 }
 
-int
-cannot_fetch_register (int regno)
+static int
+m68k_cannot_fetch_register (int regno)
 {
-  return (regno >= num_regs);
+  return (regno >= m68k_num_regs);
 }
+
+struct linux_target_ops the_low_target = {
+  m68k_num_regs,
+  m68k_regmap,
+  m68k_cannot_fetch_register,
+  m68k_cannot_store_register,
+};
diff -purN gdb-5.2.1-orig/gdb/gdbserver/linux-mips-low.c gdb-5.2.1/gdb/gdbserver/linux-mips-low.c
--- gdb-5.2.1-orig/gdb/gdbserver/linux-mips-low.c	Wed Feb 27 08:07:39 2002
+++ gdb-5.2.1/gdb/gdbserver/linux-mips-low.c	Tue Sep  2 14:04:41 2003
@@ -26,14 +26,14 @@
 #include <sys/reg.h>
 #endif
 
-int num_regs = 90;
+#define mips_num_regs 90
 
 #include <asm/ptrace.h>
 
 /* Return the ptrace ``address'' of register REGNO. */
 
 /* Matches mips_generic32_regs */
-int regmap[] = {
+static int mips_regmap[] = {
   0,  1,  2,  3,  4,  5,  6,  7,
   8,  9,  10, 11, 12, 13, 14, 15,
   16, 17, 18, 19, 20, 21, 22, 23,
@@ -63,10 +63,10 @@ int regmap[] = {
    ZERO_REGNUM.  We also can not set BADVADDR, CAUSE, or FCRIR via
    ptrace().  */
 
-int
-cannot_fetch_register (int regno)
+static int
+mips_cannot_fetch_register (int regno)
 {
-  if (regmap[regno] == -1)
+  if (mips_regmap[regno] == -1)
     return 1;
 
   if (find_regno ("zero") == regno)
@@ -75,10 +75,10 @@ cannot_fetch_register (int regno)
   return 0;
 }
 
-int
-cannot_store_register (int regno)
+static int
+mips_cannot_store_register (int regno)
 {
-  if (regmap[regno] == -1)
+  if (mips_regmap[regno] == -1)
     return 1;
 
   if (find_regno ("zero") == regno)
@@ -95,3 +95,61 @@ cannot_store_register (int regno)
 
   return 0;
 }
+
+static CORE_ADDR
+mips_get_pc ()
+{
+  unsigned long pc;
+  collect_register_by_name ("pc", &pc);
+  return pc;
+}
+
+static void
+mips_set_pc (CORE_ADDR pc)
+{
+  unsigned long newpc = pc;
+  supply_register_by_name ("pc", &newpc);
+}
+
+/* Correct in either endianness.  */
+static const unsigned long mips_breakpoint = 0x0005000d;
+#define mips_breakpoint_len 4
+
+/* We only place breakpoints in empty marker functions, and thread locking
+   is outside of the function.  So rather than importing software single-step,
+   we can just run until exit.  */
+static CORE_ADDR
+mips_reinsert_addr ()
+{
+  unsigned long pc;
+  collect_register_by_name ("ra", &pc);
+  return pc;
+}
+
+static int
+mips_breakpoint_at (CORE_ADDR where)
+{
+  unsigned long insn;
+
+  (*the_target->read_memory) (where, (char *) &insn, 4);
+  if (insn == mips_breakpoint)
+    return 1;
+
+  /* If necessary, recognize more trap instructions here.  GDB only uses the
+     one.  */
+  return 0;
+}
+
+struct linux_target_ops the_low_target = {
+  mips_num_regs,
+  mips_regmap,
+  mips_cannot_fetch_register,
+  mips_cannot_store_register,
+  mips_get_pc,
+  mips_set_pc,
+  (const char *) &mips_breakpoint,
+  mips_breakpoint_len,
+  mips_reinsert_addr,
+  0,
+  mips_breakpoint_at,
+};
diff -purN gdb-5.2.1-orig/gdb/gdbserver/linux-ppc-low.c gdb-5.2.1/gdb/gdbserver/linux-ppc-low.c
--- gdb-5.2.1-orig/gdb/gdbserver/linux-ppc-low.c	Wed Feb 27 08:07:39 2002
+++ gdb-5.2.1/gdb/gdbserver/linux-ppc-low.c	Tue Sep  2 14:04:41 2003
@@ -25,10 +25,10 @@
 
 #include <asm/ptrace.h>
 
-int num_regs = 71;
+#define ppc_num_regs 71
 
 /* Currently, don't check/send MQ.  */
-int regmap[] =
+static int ppc_regmap[] =
  {PT_R0 * 4,     PT_R1 * 4,     PT_R2 * 4,     PT_R3 * 4,
   PT_R4 * 4,     PT_R5 * 4,     PT_R6 * 4,     PT_R7 * 4,
   PT_R8 * 4,     PT_R9 * 4,     PT_R10 * 4,    PT_R11 * 4,
@@ -46,17 +46,71 @@ int regmap[] =
   PT_FPR0*4+192,  PT_FPR0*4+200,  PT_FPR0*4+208,  PT_FPR0*4+216,
   PT_FPR0*4+224,  PT_FPR0*4+232,  PT_FPR0*4+240,  PT_FPR0*4+248,
   PT_NIP * 4,    PT_MSR * 4,    PT_CCR * 4,    PT_LNK * 4,
-  PT_CTR * 4,    PT_XER * 4,    -1, };
+  PT_CTR * 4,    PT_XER * 4,    PT_FPSCR * 4, };
 
-int
-cannot_store_register (int regno)
+static int
+ppc_cannot_store_register (int regno)
+{
+  /* Some kernels do not allow us to store fpscr.  */
+  if (regno == find_regno ("fpscr"))
+    return 2;
+
+  return 0;
+}
+
+static int
+ppc_cannot_fetch_register (int regno)
 {
   return 0;
 }
 
-int
-cannot_fetch_register (int regno)
+static CORE_ADDR
+ppc_get_pc (void)
 {
+  unsigned long pc;
+
+  collect_register_by_name ("pc", &pc);
+  return (CORE_ADDR) pc;
+}
+
+static void
+ppc_set_pc (CORE_ADDR pc)
+{
+  unsigned long newpc = pc;
+
+  supply_register_by_name ("pc", &newpc);
+}
+
+/* Correct in either endianness.  Note that this file is
+   for PowerPC only, not PowerPC64.
+   This instruction is "twge r2, r2", which GDB uses as a software
+   breakpoint.  */
+static const unsigned long ppc_breakpoint = 0x7d821008;
+#define ppc_breakpoint_len 4
+
+static int
+ppc_breakpoint_at (CORE_ADDR where)
+{
+  unsigned long insn;
+
+  (*the_target->read_memory) (where, (char *) &insn, 4);
+  if (insn == ppc_breakpoint)
+    return 1;
+  /* If necessary, recognize more trap instructions here.  GDB only uses the
+     one.  */
   return 0;
 }
 
+struct linux_target_ops the_low_target = {
+  ppc_num_regs,
+  ppc_regmap,
+  ppc_cannot_fetch_register,
+  ppc_cannot_store_register,
+  ppc_get_pc,
+  ppc_set_pc,
+  (const char *) &ppc_breakpoint,
+  ppc_breakpoint_len,
+  NULL,
+  0,
+  ppc_breakpoint_at,
+};
diff -purN gdb-5.2.1-orig/gdb/gdbserver/linux-s390-low.c gdb-5.2.1/gdb/gdbserver/linux-s390-low.c
--- gdb-5.2.1-orig/gdb/gdbserver/linux-s390-low.c	Thu Feb 28 17:58:14 2002
+++ gdb-5.2.1/gdb/gdbserver/linux-s390-low.c	Tue Sep  2 14:04:41 2003
@@ -27,9 +27,9 @@
 
 #include <asm/ptrace.h>
 
-int num_regs = 67;
+#define s390_num_regs 67
 
-int regmap[] = {
+static int s390_regmap[] = {
   PT_PSWMASK, PT_PSWADDR,
 
   PT_GPR0, PT_GPR1, PT_GPR2, PT_GPR3,
@@ -62,20 +62,27 @@ int regmap[] = {
 #endif
 };
 
-int
-cannot_fetch_register (int regno)
+static int
+s390_cannot_fetch_register (int regno)
 {
-  if (regmap[regno] == -1)
+  if (s390_regmap[regno] == -1)
     return 1;
 
   return 0;
 }
 
-int
-cannot_store_register (int regno)
+static int
+s390_cannot_store_register (int regno)
 {
-  if (regmap[regno] == -1)
+  if (s390_regmap[regno] == -1)
     return 1;
 
   return 0;
 }
+
+struct linux_target_ops the_low_target = {
+  s390_num_regs,
+  s390_regmap,
+  s390_cannot_fetch_register,
+  s390_cannot_store_register,
+};
diff -purN gdb-5.2.1-orig/gdb/gdbserver/linux-sh-low.c gdb-5.2.1/gdb/gdbserver/linux-sh-low.c
--- gdb-5.2.1-orig/gdb/gdbserver/linux-sh-low.c	Wed Feb 27 08:07:39 2002
+++ gdb-5.2.1/gdb/gdbserver/linux-sh-low.c	Tue Sep  2 14:04:41 2003
@@ -28,10 +28,10 @@
 
 #include <asm/ptrace.h>
 
-int num_regs = 41;
+#define sh_num_regs 41
 
 /* Currently, don't check/send MQ.  */
-int regmap[] = {
+static int sh_regmap[] = {
  0,	4,	8,	12,	16,	20,	24,	28,
  32,	36,	40,	44,	48,	52,	56,	60,
 
@@ -45,15 +45,61 @@ int regmap[] = {
  REG_FPREG0+48,  REG_FPREG0+52,  REG_FPREG0+56,  REG_FPREG0+60,
 };
 
-int
-cannot_store_register (int regno)
+static int
+sh_cannot_store_register (int regno)
 {
   return 0;
 }
 
-int
-cannot_fetch_register (int regno)
+static int
+sh_cannot_fetch_register (int regno)
 {
   return 0;
 }
 
+static CORE_ADDR
+sh_get_pc ()
+{
+  unsigned long pc;
+  collect_register_by_name ("pc", &pc);
+  return pc;
+}
+
+static void
+sh_set_pc (CORE_ADDR pc)
+{
+  unsigned long newpc = pc;
+  supply_register_by_name ("pc", &newpc);
+}
+
+/* Correct in either endianness, obviously.  */
+static const unsigned short sh_breakpoint = 0xc3c3;
+#define sh_breakpoint_len 2
+
+static int
+sh_breakpoint_at (CORE_ADDR where)
+{
+  unsigned short insn;
+
+  (*the_target->read_memory) (where, (char *) &insn, 2);
+  if (insn == sh_breakpoint)
+    return 1;
+
+  /* If necessary, recognize more trap instructions here.  GDB only uses the
+     one.  */
+  return 0;
+}
+
+struct linux_target_ops the_low_target = {
+  sh_num_regs,
+  sh_regmap,
+  sh_cannot_fetch_register,
+  sh_cannot_store_register,
+  sh_get_pc,
+  sh_set_pc,
+  (const char *) &sh_breakpoint,
+  sh_breakpoint_len,
+  NULL,
+  0,
+  sh_breakpoint_at,
+};
diff -purN gdb-5.2.1-orig/gdb/gdbserver/linux-x86-64-low.c gdb-5.2.1/gdb/gdbserver/linux-x86-64-low.c
--- gdb-5.2.1-orig/gdb/gdbserver/linux-x86-64-low.c	Thu Mar  7 21:56:18 2002
+++ gdb-5.2.1/gdb/gdbserver/linux-x86-64-low.c	Tue Sep  2 14:04:41 2003
@@ -28,12 +28,15 @@
 #include <sys/procfs.h>
 #include <sys/ptrace.h>
 
-static int regmap[] = {
-  RAX, RDX, RCX, RBX,
+#define	X86_64_NUM_GREGS 22
+
+static int x86_64_regmap[X86_64_NUM_GREGS] = {
+  RAX, RBX, RCX, RDX,
   RSI, RDI, RBP, RSP,
   R8, R9, R10, R11,
   R12, R13, R14, R15,
-  RIP, EFLAGS
+  RIP, EFLAGS,
+  DS, ES, FS, GS
 };
 
 static void
@@ -41,8 +44,8 @@ x86_64_fill_gregset (void *buf)
 {
   int i;
 
-  for (i = 0; i < 18; i++)
-    collect_register (i, ((char *) buf) + regmap[i]);
+  for (i = 0; i < X86_64_NUM_GREGS; i++)
+    collect_register (i, ((char *) buf) + x86_64_regmap[i]);
 }
 
 static void
@@ -50,8 +53,8 @@ x86_64_store_gregset (void *buf)
 {
   int i;
 
-  for (i = 0; i < 18; i++)
-    supply_register (i, ((char *) buf) + regmap[i]);
+  for (i = 0; i < X86_64_NUM_GREGS; i++)
+    supply_register (i, ((char *) buf) + x86_64_regmap[i]);
 }
 
 static void
@@ -66,11 +69,19 @@ x86_64_store_fpregset (void *buf)
   i387_fxsave_to_cache (buf);
 }
 
-
 struct regset_info target_regsets[] = {
   { PTRACE_GETREGS, PTRACE_SETREGS, sizeof (elf_gregset_t),
+    GENERAL_REGS,
     x86_64_fill_gregset, x86_64_store_gregset },
   { PTRACE_GETFPREGS, PTRACE_SETFPREGS, sizeof (elf_fpregset_t),
+    FP_REGS,
     x86_64_fill_fpregset, x86_64_store_fpregset },
-  { 0, 0, -1, NULL, NULL }
+  { 0, 0, -1, -1, NULL, NULL }
+};
+
+struct linux_target_ops the_low_target = {
+  -1,
+  NULL,
+  NULL,
+  NULL,
 };
